//+------------------------------------------------------------------+
//|                                                   MTF signal.mq4 |
//|                                                            Sehat |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Sehat"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern bool _email = false;
extern bool _alert = true;

double trix5=0;
double trix15=0;
double trix60=0;

int trix5up = 0;
int trix15up = 0;
int trix60up = 0;

double dHigh = 0;

string comment="";

bool alerted = NULL;

string sSubject="";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   Comment("");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   comment = "5";
   comment = comment + ",15";
   comment = comment + ",60";
   comment = comment + ":";

//----


//Get the trix value for each timeframe and also calculate direction
   trix5 = iCustom(NULL,5,"smSuper TRIX_v1",3,"averages",1,1,1,"input_price",0,"Signals",true,false,false,500,0,1);
   if (trix5 > 0) trix5up=1;
      else trix5up=-1;
   
   trix15 = iCustom(NULL,15,"smSuper TRIX_v1",3,"averages",1,1,1,"input_price",0,"Signals",true,false,false,500,0,1);
   if (trix15 > 0) trix15up=1;
      else trix15up=-1;

   trix60 = iCustom(NULL,60,"smSuper TRIX_v1",3,"averages",1,1,1,"input_price",0,"Signals",true,false,false,500,0,1);
   if (trix60 > 0) trix60up=1;
      else trix60up=-1;

 
//ACTION START HERE

//Up signal is out
   if (trix5up==1 && trix15up==1 && trix60up==1) {
      if (!alerted) {
         sSubject = comment + " Buy for " + Symbol();
         alerted = true;
         if (_alert)
            Alert(comment + " Buy for " + Symbol());
         if (_email)
            SendMail(sSubject,GetMailBody());
      }
   }
//Down signal is out
   else if (trix5up==-1 && trix15up==-1 && trix60up==-1) {
      if (!alerted) {
         sSubject = comment + " Sell for " + Symbol();
         alerted = true;
         if (_alert)
            Alert(comment + " Sell for " + Symbol());
         if (_email)
            SendMail(sSubject,GetMailBody());
      }
   }
//No signal
   else {
      alerted = false;
   }

//visual

//----
   return(0);
  }
//+------------------------------------------------------------------+

//This function will format up signal as L and down signal as S
string GetTrix(int iTimeFrame, int iShift) {
   double trix = iCustom(NULL,iTimeFrame,"smSuper TRIX_v1",3,"averages",1,1,1,"input_price",0,"Signals",true,false,false,500,0,iShift);
   if (trix > 0) return("L");
      else return("S");
}


//this function will try to visualize smtrix mtf
string GetMailBody() {
   int iCtr=0;
   int jCtr=0;
   string s1="";
   string sText="";
   
   sText = sText + "5 mins signal: |";
   for (iCtr=24; iCtr>0; iCtr--) {
      sText = sText + GetTrix(5,iCtr) + "|";
   }
   sText = sText + "\n";

   sText = sText + "15 mins signal: |";
   for (iCtr=8; iCtr>0; iCtr--) {
      s1 = GetTrix(15,iCtr);
      for ( jCtr=1; jCtr<=3; jCtr++) {
         sText = sText + s1 + "|";
      }
   }
   sText = sText + "\n";

   sText = sText + "Hourly signal: |";
   for (iCtr=2; iCtr>0; iCtr--) {
      s1 = GetTrix(60,iCtr);
      for (jCtr=1; jCtr<=12; jCtr++) {
         sText = sText + s1 + "|";
      }
   }
   sText = sText + "\n";
      
   sText = sText + "Last 2 bar\'s High: " + High[2] + "|" + High[1] + "\n";
   sText = sText + "Last 2 bar\'s Close: " + Close[2] + "|" + Close[1] + "\n";
   
   return(sText);
}